import { world, ItemStack, MinecraftBlockTypes } from "@minecraft/server";
import { ModalFormData } from "@minecraft/server-ui";

function nowXp(player, removeXp, getXp) {
    player.addLevels(-(player.level + 1));
    const nowPlayerXp = getXp - removeXp;
    player.addExperience(nowPlayerXp);
}

//XPUI
function xpUI(ModalFormData, player, durability, container, getXp, selectedSlot, itemStack) {
    const model = ['output', 'input'];
    const xpUI = new ModalFormData()
        .title('xpBook.xpUi.title')
        .dropdown('xpBook.xpUi.dropdown', model)
        .textField('xpBook.xpUi.textField', ' ')
    xpUI.show(player).then(ui => {
        const select = ui.formValues;
        const removeXp = parseInt(select[1]);
        if (!isNaN(removeXp)) {
            switch (select[0]) {
                case 0:
                    if (removeXp > durability.maxDurability || (durability.damage == 0 ? (removeXp - durability.damage) * -1 : durability.damage - removeXp) > 0) {
                        console.warn(':(');
                        console.warn(durability.damage == 0 ? (removeXp - durability.damage) * -1 : removeXp - durability.damage)
                    } else {
                        player.addExperience(removeXp);
                        durability.damage += removeXp;
                        console.warn(removeXp - durability.damage)
                        container.setItem(selectedSlot, itemStack);
                    }
                    break;
                case 1:
                    if (removeXp > getXp || durability.damage < removeXp) {
                        console.warn(':(');
                    } else {
                        nowXp(player, removeXp, getXp);
                        durability.damage -= removeXp;
                        container.setItem(selectedSlot, itemStack);
                    }
                    break;
            }
        } else {
            console.warn(':(')
        }

    })
}

//itemUse中xp算法
function setAllXp(player, itemStack, getXp, container) {
    const durability = itemStack.getComponent('minecraft:durability');
    const nowBookXp = durability.maxDurability - durability.damage;
    const selectedSlot = player.selectedSlot;
    switch (selectedSlot) {
        case 0:
            durability.damage += nowBookXp;
            player.addExperience(nowBookXp);
            break;
        case 1:
            if (getXp >= durability.damage) {
                nowXp(player, durability.damage, getXp)
                durability.damage -= durability.damage;
            } else {
                nowXp(player, getXp, getXp)
                durability.damage -= getXp;
            }
            break;
        default:
            xpUI(ModalFormData, player, durability, container, getXp, selectedSlot, itemStack);
            break;
    }
    container.setItem(selectedSlot, itemStack);
}

//显示信息
function tile(player, getXp, itemStack) {
    const durability = itemStack.getComponent('minecraft:durability');
    const getXpLevel = player.level;
    const getLevelXp = player.xpEarnedAtCurrentLevel;
    const getNeedXp = player.totalXpNeededForNextLevel;
    player.onScreenDisplay.setActionBar(`Player[§6${player.name}§f]\nXP:§2${getLevelXp}§6/§2${getNeedXp}§f\nXP Book§2${durability.maxDurability - durability.damage}/${durability.maxDurability}§fxp\nAll XP§2${getXp}§fxp\nPlayer Level§2${getXpLevel}§fL\nThere's still one level left to go§2${getNeedXp - getLevelXp}§fxp`);
}

//啥用没有的东西
function xpBookUse(xpBookUse) {
    const player = xpBookUse.source;
    const itemStack = xpBookUse.item;
    const xpBookId = itemStack.typeId.split('_')[0];
    if (player.typeId == 'minecraft:player' && xpBookId == 'xpbook:xpbook') {
        const getXp = player.getTotalXp();
        const container = player.getComponent('minecraft:inventory').container;
        if (player.isSneaking) {
            setAllXp(player, itemStack, getXp, container);
        } else {
            tile(player, getXp, itemStack);
        }
    }
}
function xpBookLevel(args) {
    const blockList = [
        'minecraft:copper_block',
        'minecraft:iron_block',
        'minecraft:gold_block',
        'minecraft:diamond_block',
        'minecraft:emerald_block'
    ];
    const player = args.source;
    const itemStack = args.item;
    const xpBookId = itemStack.typeId.split('_');
    if (player.typeId == 'minecraft:player' && xpBookId[0] == 'xpbook:xpbook') {
        const getLevel = player.level;
        const blockLocation = args.getBlockLocation();
        const block = player.dimension.getBlock(blockLocation);
        if (block.typeId == blockList[xpBookId[1]] && getLevel >= xpBookId[1] * 3) {
            console.warn(1)
            player.dimension.fillBlocks(blockLocation, blockLocation, MinecraftBlockTypes.air);
            const newBook = new ItemStack(`${xpBookId[0]}_${parseInt(xpBookId[1]) + 1}`);
            const container = player.getComponent('minecraft:inventory').container;
            const oldDurability = itemStack.getComponent('minecraft:durability'), newDurability = newBook.getComponent('minecraft:durability');
            player.addLevels(-xpBookId[1] * 3);
            newDurability.damage = newDurability.maxDurability - (oldDurability.maxDurability - oldDurability.damage);//大致是可以优化的，如果可以优化，那就是我啥比了
            container.setItem(player.selectedSlot, newBook);
        }
    }
}
world.events.itemUseOn.subscribe(xpBookLevel);
world.events.itemUse.subscribe(xpBookUse);